<?php



if (!defined('ABSPATH')) {
	exit();
}


if (!class_exists('App_Expert_Settings_Page')) {

	class App_Expert_Settings_Page
	{

		/**
		 * @var array
		 */
		private $options;

		public function __construct()
		{
			add_action('admin_menu', [$this, 'add_settings_page']);
			add_action('admin_init', [$this, 'register_settings']);
		}


		public function add_settings_page()
		{
			add_options_page('App Experts Settings', 'App Experts', 'manage_options', 'App Experts', [$this, 'render_settings_page']);
		}

		public function register_settings()
		{
			//register_setting('app_expert_options', 'app_expert_options');
                        register_setting('aeci_options', 'aeci_options');
                        add_settings_section('App Experts', __('Categories Images settings', 'app-expert'), [$this, 'AppExpertSectionText'], 'aeci-options');
                        add_settings_field('ae_included_taxonomies', __('Taxonomies', 'app-expert'), [$this, 'AppExpertExcludedTaxonomies'], 'aeci-options', 'App Experts');
		}
                
                public function AppExpertSectionText()
                {
                    echo '<p>'.__('Please select the taxonomies you want to add image to.', 'app-expert').'</p>';
                }
                
                public function AppExpertExcludedTaxonomies()
                {
                    $options = get_option('aeci_options');
                    $disabled_taxonomies = ['nav_menu', 'link_category', 'post_format'];
                    foreach (get_taxonomies() as $tax) : if (in_array($tax, $disabled_taxonomies)) continue; ?>
                        <input type="checkbox" name="aeci_options[included_taxonomies][<?php echo $tax ?>]" value="<?php echo $tax ?>" <?php checked(isset($options['included_taxonomies'][$tax])); ?> /> <?php echo $tax ;?><br />
                    <?php endforeach;
                }

		public function render_settings_page()
		{
                    ?>
                    <h2>App Experts Settings</h2>
                    <form method="post" action="options.php">
			<br>
			<h3>Server htaccess settings</h3>
			<p>Make sure that your server .htaccess file is configured to allow <strong>Authorization Header</strong></p>

			<xmp>
				<IfModule mod_rewrite.c>
					RewriteEngine On
					RewriteBase /
					RewriteRule ^index\.php$ - [L]
					RewriteCond %{REQUEST_FILENAME} !-f
					RewriteCond %{REQUEST_FILENAME} !-d
					RewriteRule . /index.php [L]
					RewriteCond %{HTTP:Authorization} ^(.*)
					RewriteRule ^(.*) - [E=HTTP_AUTHORIZATION:%1]
				</IfModule>
				SetEnvIf Authorization "(.*)" HTTP_AUTHORIZATION=$1
				# END WordPress
			</xmp>

			<hr>
                        <?php settings_fields('aeci_options'); ?>
                        <?php do_settings_sections('aeci-options'); ?>
                        <hr>
                        <?php do_settings_sections('aepn-options'); ?>
                        <?php submit_button(); ?>
                    </form>
		<?php

		}
	}
}
new App_Expert_Settings_Page();
