<?php
if (!defined('ABSPATH')) {
	exit();
}

if (!class_exists('App_Expert_Post_Translation_Meta_Data')) {
	class App_Expert_Post_Translation_Meta_Data implements App_Expert_IResponnse_Meta_data
	{

		public function support_listing()
		{
			return false;
		}

		/**
		 * @param array $data
		 *
		 * @return void
		 */
		public  function attach_data(array &$data)
		{
			if (!isset($data['id']) || empty($data['id']))
				return;

			// Check WPML
			if (!in_array('sitepress-multilingual-cms/sitepress.php', apply_filters('active_plugins', get_option('active_plugins')))) {
				return;
			}

			$language = $_GET['wpml_language'] ? sanitize_key($_GET['wpml_language']) : null;
			if (!$language) {
				return;
			}
			$type = $data['type'] ?  $data['type'] : "";
			$trans_id = apply_filters('wpml_object_id', $data['id'], $type, false, $language);
			if (!$trans_id || $data['id'] == $trans_id) {
				return;
			}

			// Override content with translated content
			$post = get_post($trans_id);
			if(!$post){
				return;
			}

			$data['id'] =  $trans_id;
			$data['title'] =  array_merge($data['title'], [
				'rendered' => $post->post_title
			]);
			$data['content'] = array_merge($data['content'], [
				'rendered' => $post->post_content,

			]);
			$data['excerpt'] = array_merge($data['excerpt'], [
				'rendered' => $post->post_excerpt,
			]);
		}
	}
}
