<?php
if (!defined('ABSPATH')){
	exit();
}

if (!class_exists('App_Expert_Response_Meta_Data')){
	class App_Expert_Response_Meta_Data {


		/**
		 * @var array App_Expert_IResponnse_Meta_data
		 */
		private $app_expert_meta_data_attachers;

		public function __construct(array $response_attachers) {
			$this->app_expert_meta_data_attachers = $response_attachers;
		}


		/**
		 * @param WP_REST_Response $response
		 *
		 * @param bool $is_single_data
		 *
		 * @return WP_REST_Response
		 */
		public function attach_meta_data(WP_REST_Response $response , bool $is_single_data){
			$data_collection = $response->get_data();

			if ($is_single_data){
				foreach ($this->app_expert_meta_data_attachers as $meta_data){
					$meta_data->attach_data($data_collection);
				}
			}else{
				foreach ($data_collection as &$data){
					foreach ($this->app_expert_meta_data_attachers as $meta_data){
						if(!($meta_data instanceof App_Expert_IResponnse_Meta_data) || $meta_data->support_listing()){
							$meta_data->attach_data($data);
						}
					}
				}
			}

			$response->set_data($data_collection);

			return $response;
		}

	}
}
