<?php
if (!defined('ABSPATH')) {
    exit();
}

if (!class_exists('App_Expert_WC_Rest_Products_Controller')) {

    if (class_exists('WC_REST_Products_Controller')) {
       
        /**
         * Extends Woocommerce products endpoint to allow filter by multiple attributes
         * @inheritDoc
         */
        class App_Expert_WC_Rest_Products_Controller extends WC_REST_Products_Controller
        {

            /**
             * @inheritDoc
             */
            protected function prepare_objects_query($request)
            {
                $args = parent::prepare_objects_query($request);
                
                // Filter by attribute and term.
                if (!empty($request['appexpert_attributes']) && is_array($request['appexpert_attributes'])) {

                    $additional_tax_query = [];
                    $all_available_attr_names = wc_get_attribute_taxonomy_names();
                    foreach ($request['appexpert_attributes'] as $attribute_name => $attribute_term_ids) {
                        if (in_array($attribute_name, $all_available_attr_names, true)) {
                            $additional_tax_query[] = array(
                                'taxonomy' => $attribute_name,
                                'field'    => 'term_id',
                                'terms'    => explode(",", $attribute_term_ids),
                            );
                        }
                    }
                    if (!isset($args['tax_query'])) {
                        $args['tax_query'] = [];
                    }
                    $args['tax_query'] = array_merge($additional_tax_query, $args['tax_query']); // WPCS: slow query ok.
                }


                return $args;
            }
        }

        $app_expert_wc_products_controller = new App_Expert_WC_Rest_Products_Controller();
        $app_expert_wc_products_controller->register_routes();
    }
}
